class KohonenSet{
  float learningRate= .15;
    //old
  //int numNodes, numWeights;
  //int vNodes, hNodes;
  //new
  int numNodes, numFactors, nodes, nodes3D, numNodes3D;
  float MAX_ITERATIONS = 250;
  float ITERATION_CAP = 25;
  int iterationCounter = 0;
  float neighborDist;
  //old
  //float weightArray[][]; //an array of 'node' by 'weight' dimensions
  //new
  float factorArray[][];
  float kset[][];  //values to be sorted
  Integer ksetRandomOrder[];
  boolean useFactors[];
  ArrayList <County> counties;


  void KohonenSet(){
  }

  void initWeights3D(int nodes3D, int numFactors){
    numNodes3D = nodes3D*nodes3D*nodes3D;
    factorArray = new float[numNodes3D][numFactors];
    this.nodes3D = nodes3D;
    this.numFactors = numFactors;
    for (int i=0; i<numNodes3D; i++){
      for (int j=0; j<numFactors; j++){
        factorArray[i][j] = random(100);
      }
    }
    ksetRandomOrder = new Integer[kset.length];
    for (int i=0; i<kset.length; i++){
      ksetRandomOrder[i] = new Integer(i);
    }
  }
  

  void initWeights(int nodes, int numFactors){
    factorArray = new float[nodes*nodes][numFactors];
    numNodes = nodes*nodes;
    this.nodes = nodes;
    this.numFactors = numFactors;
    for (int i=0; i<numNodes; i++){
      for (int j=0; j<numFactors; j++){
        factorArray[i][j] = random(100);
      }
    }
    ksetRandomOrder = new Integer[kset.length];
    for (int i=0; i<kset.length; i++){
      ksetRandomOrder[i] = new Integer(i);
    }
  }
  
  void reset(){
    iterationCounter = 0;
  }
  //new
    void train(boolean[] useFactors){
    Collections.shuffle(Arrays.asList(ksetRandomOrder));    
    if (iterationCounter<ITERATION_CAP){
      //      neighborDist = 30+100-(100*(iterationCounter/MAX_ITERATIONS));
      //neighborDist = 5+(width/12*(1-(iterationCounter/MAX_ITERATIONS)));
      neighborDist = 5+(20*(1-(iterationCounter/MAX_ITERATIONS)));

      for (int k=0; k<kset.length; k++){
        int best = bestMatch(ksetRandomOrder[k].intValue(), useFactors);
        for (int node=0; node<numNodes; node++){
          float kxMove = k%nodes;
          //old way
          float kyMove = k/nodes;
          //try
          float tempFloat = (int)k/4;
          //try this
          //tempFloat = (int)k/16;
          kxMove = tempFloat%nodes;
          kyMove = tempFloat/nodes;
          
          //new way
          //float temp = k/nodes;
          //temp = (int) temp;
          //float kyMove =temp%nodes;
          //println("kxMove " +kxMove + " , kyMove: " + kyMove);
          float bestxMove = best%nodes;
          //old way
          float bestyMove = best/nodes;
          //new way
          //temp = best/nodes;
          //temp = (int) temp;
          //float bestyMove = temp%nodes;
          float mult = 0.8*width/nodes;
          float nodeX = mult*kxMove;
          float nodeY = mult*kyMove;
          float bestX = mult*bestxMove;
          float bestY = mult*bestyMove;
          float nodeDist = constrain(dist(nodeX,nodeY,bestX, bestY),0,neighborDist);
          for (int i=0; i<numFactors; i++){
            if(useFactors[i]){
            if (nodeDist == 0){
              factorArray[node][i] = kset[ksetRandomOrder[k].intValue()][i];
            }
            else {
              float percent = learningRate*(1-(nodeDist/neighborDist));
              factorArray[node][i] = (1-percent)*factorArray[node][i] + percent*kset[ksetRandomOrder[k].intValue()][i];
            }
            }
          }
        }
      }
    iterationCounter++;
    //println(iterationCounter);
    hint(DISABLE_DEPTH_TEST);
    cam.beginHUD();
    cp5.draw();
    textAlign(LEFT);
    textSize(14);
    text("Self-Organization Iteration: " + iterationCounter + " of max " + ITERATION_CAP ,width/3, height-height/20);
    cam.endHUD();
    hint(ENABLE_DEPTH_TEST);
    
    } 
  }
  
  
      void train3D(boolean[] useFactors){
    Collections.shuffle(Arrays.asList(ksetRandomOrder));    
    if (iterationCounter<ITERATION_CAP){
      //      neighborDist = 30+100-(100*(iterationCounter/MAX_ITERATIONS));
      neighborDist = 11+(width*0.76*(1-(iterationCounter/MAX_ITERATIONS)));
      for (int k=0; k<kset.length; k++){
        int best = bestMatch3D(ksetRandomOrder[k].intValue(), useFactors);
        for (int node=0; node<numNodes3D; node++){
          float bestxMove = best%nodes3D;
          float temp = best/nodes3D;
          temp = (int) temp;
          temp = temp%nodes3D;
          float bestyMove = temp;
          temp = best/nodes3D;
          temp = temp/nodes3D;
          temp = (int) temp;
          float bestzMove = temp;
          float kxMove = k%nodes3D;
          temp = k/nodes3D;
          temp = (int) temp;
          temp = temp%nodes3D;
          float kyMove = temp;
          temp = k/nodes3D;
          temp = temp/nodes3D;
          temp = (int) temp;
          float kzMove = temp;

          float mult = 0.8*width/nodes;
          float xDiff = mult*(kxMove-bestxMove);
          float yDiff = mult*(kyMove-bestyMove);
          float zDiff = mult*(kzMove-bestzMove);
          
          float nodeDist = constrain(sqrt(sq(xDiff)+sq(yDiff)+sq(zDiff)),0,neighborDist);
          for (int i=0; i<numFactors; i++){
            if(useFactors[i]){
            if (nodeDist == 0){
              factorArray[node][i] = kset[ksetRandomOrder[k].intValue()][i];
            }
            else {
              float percent = learningRate*(1-(nodeDist/neighborDist));
              factorArray[node][i] = (1-percent)*factorArray[node][i] + percent*kset[ksetRandomOrder[k].intValue()][i];
            }
            }
          }
        }
      }
    } 
    iterationCounter++;
  }
  

  int bestMatch(int input, boolean [] useFactors){
    int best=0; //arbitrary
    float bestFitDistance = 900000; //arbitrarily high
    for (int node=0; node<numNodes; node++){
      float sum = 0;
      for (int i=0; i<numFactors; i++){
        if(useFactors[i]){
        sum += sq(kset[input][i]-factorArray[node][i]);
        //println("input:" + input + " i:" + i +" kset[input][i]:" + kset[input][i] +" node:" + node);
        }
      }
      //println("check2");
      float distance = sqrt(sum);
      if (distance <= bestFitDistance){
        bestFitDistance = distance;
        best = node;
        
      }
      //println("check3");
    }
    return(best);
  }

  int bestMatch3D(int input, boolean [] useFactors){
    int best=0; //arbitrary
    float bestFitDistance = 900000; //arbitrarily high
    for (int node=0; node<numNodes3D; node++){
      float sum = 0;
      for (int i=0; i<numFactors; i++){
        if(useFactors[i]){
        sum += sq(kset[input][i]-factorArray[node][i]);
        }
      }
      float distance = sqrt(sum);
      if (distance <= bestFitDistance){
        bestFitDistance = distance;
        best = node;  
      }
    }
    return(best);
  }

//draw points
  void drawPoints(boolean[] useFactors, ArrayList <County> counties){
    //draw points and labels
    for (int i=0; i<kset.length; i++){
      int best = bestMatch(i, useFactors);
      //println("best " +best + ", int" + i);
      pushMatrix();
      float xMove = best%nodes;
      //old way
      float yMove = best/nodes;
            //new way
      //float yMove = ((int)(best/nodes))%nodes;
      float mult = 0.8*width/nodes;
      //always life expectancy
      float zMove = map(kset[i][35],0,100,0, 0.8*width);
      float x= -width/2 + xMove*mult;
      float y= width/2 - yMove*mult;
      float z= -width/2 + zMove;
      translate(x,y,z);
      //switch y & z
      //translate(x,-z,-y);
      //println("x " +x + " y " + y + " z " +z);
      //translate((500/(2*hNodes))+500/hNodes*(bmu%hNodes),(500/(2*vNodes))+500/vNodes*(bmu/hNodes));
      color c = colorBar.get((int)map(kset[i][35], 0, 100, (colorBar.width), 0), colorBar.height/2);
      stroke(c);
      strokeWeight(6);
      point(0,0,0);
      popMatrix();
    }    
  }
  
  //draw text instead of points
    void drawText(boolean[] useFactors, ArrayList <County> counties, String[] factorNames){
    //draw points and labels
    for (int i=0; i<kset.length; i++){
      int best = bestMatch(i, useFactors);
      //println("best " +best + ", int" + i);
      pushMatrix();
      float xMove = best%nodes;
      //old way
      float yMove = best/nodes;
            //new way
      //float yMove = ((int)(best/nodes))%nodes;
      float mult = 0.8*width/nodes;
      //always life expectancy
      float zMove = map(kset[i][35],0,100,0, 0.8*width);
      float x= -width/2 + xMove*mult;
      float y= width/2 - yMove*mult;
      float z= -width/2 + zMove;
      //make things bigger
      x= -width*1.2 + 2.2*xMove*mult;
      y= width*0.9 - 2.2*yMove*mult;
      z= -width/2 + 2.2*zMove;
      translate(x,y,z);
      //switch y & z
      //translate(x,-z,-y);
      //println("x " +x + " y " + y + " z " +z);
      //translate((500/(2*hNodes))+500/hNodes*(bmu%hNodes),(500/(2*vNodes))+500/vNodes*(bmu/hNodes));
      color c = colorBar.get((int)map(kset[i][35], 0, 100, (colorBar.width), 0), colorBar.height/2);
      String label = counties.get(i).county + ", " + counties.get(i).state;
      float mouseDist = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0)); 
      if (mouseDist < 25) {
        //change color
        c=color(255);
        //add factors
        for(int j=0; j<numFactors; j++){
         //used Factors and always add life expectancy
          if(useFactors[j] || j==(numFactors-1)){
          label = label + "\n" + factorNames[j];
          label = label + ": " + counties.get(i).factors[j];
          }
        }
        fill(c);
          hint(DISABLE_DEPTH_TEST);
          cam.beginHUD();
          cp5.draw();
          textAlign(CENTER);
          textSize(12);
          text(label,mouseX, mouseY);
          cam.endHUD();
          hint(ENABLE_DEPTH_TEST);
  
      }
      else{
              textAlign(LEFT);
              fill(c);
              textSize(14);
              text(label,0,0,0);
      }
      stroke(c, 200);
      strokeWeight(6);
      point(0,0,0);
      popMatrix();
    }    
  }
  
  //draw text instead of points
    void drawText3D(boolean[] useFactors, ArrayList <County> counties, String[] factorNames){
    //draw points and labels
    for (int i=0; i<kset.length; i++){
      int best = bestMatch3D(i, useFactors);
      //println("best " +best + ", int" + i);
      pushMatrix();
      float xMove = best%nodes3D;
      //old way
      float temp = best/nodes3D;
      temp = (int) temp;
      temp = temp%nodes3D;
      float yMove = temp;
      temp = best/nodes3D;
      temp = temp/nodes3D;
      temp = (int) temp;
      float zMove = temp;
      float mult = 0.8*width/nodes3D;
      float x= -width/2 + xMove*mult;
      float y= width/2 - yMove*mult;
      float z= -width/2 + zMove*mult;
      //make things bigger
      x= -width*1.2 + 2.2*xMove*mult;
      y= width*0.9 - 2.2*yMove*mult;
      z= -width/2 + 2.2*zMove;
      translate(x,y,z);
      //switch y & z
      //translate(x,-z,-y);
      //println("x " +x + " y " + y + " z " +z);
      //translate((500/(2*hNodes))+500/hNodes*(bmu%hNodes),(500/(2*vNodes))+500/vNodes*(bmu/hNodes));
      color c = colorBar.get((int)map(kset[i][35], 0, 100, (colorBar.width), 0), colorBar.height/2);
      String label = counties.get(i).county + ", " + counties.get(i).state;
      float mouseDist = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0)); 
      if (mouseDist < 25) {
        //change color
        c=color(255);
        //add factors
        for(int j=0; j<numFactors; j++){
         //used Factors and always add life expectancy
        if(useFactors[j] || j==(numFactors-1)){
        label = label + "\n" + factorNames[j];
        label = label + ": " + counties.get(i).factors[j];
        }
      }
      }
      fill(c);
      stroke(c);
      strokeWeight(2);
      point(0,0,0);
      textSize(14);
      text(label,0,0,0);
      popMatrix();
    }    
  }

}
